#! /bin/csh -f


#Write and decide the default python version in your computer
set verdist="v01"
set scrptname=`ls sxt_gti*merger*.py`
set juliadirname="./sxtjuliamodule"


mkdir -p $HOME/auxpyscrpt/

cp -R ./sxtjuliamodule $HOME/auxpyscrpt/SXTMERGER_JULIA

#Handling the readme/help documents for this script..
set readmefilestem="readme"
set outreadmestem="pyjulia_sxtevtmerger_help_${verdist}"

set docdir=$HOME/auxpyscrpt/docs

mkdir -p ${docdir}

set filtyparr=(html pdf)

foreach filtyp ($filtyparr)
    #Adding pdf/html versions of readme to docs
    if (-f "${readmefilestem}.${filtyp}") then 
        echo ${readmefilestem}.${filtyp}
        cp ${readmefilestem}.${filtyp} ${docdir}/${outreadmestem}.${filtyp};
        echo "The help file ${outreadmestem}.${filtyp} is added to the directory ${docdir}... \n Please read it carefully before using this tool";

    endif

end


#adding/aliasing shortcut to paths....
 
cp ./$scrptname $HOME/auxpyscrpt/

    
if  (-f $HOME/.cshrc ) then 

    sed -i '/PyJulia/d' $HOME/.cshrc
    sed -i '/sxtevtmergerjl/d' $HOME/.cshrc

    echo "#SXT PyJulia Events Merger Tool" >>$HOME/.cshrc
    echo 'alias sxtevtmergerjl "python '$HOME/auxpyscrpt/$scrptname' "' >>$HOME/.cshrc
    echo " The alias command \'sxtevtmergerjl\' is added to file : $HOME/.cshrc "

else if (-f $HOME/.cshrc ) then

    sed -i '/PyJulia/d' $HOME/.profile
    sed -i '/sxtevtmergerjl/d' $HOME/.profile

    echo "#SXT PyJulia Events Merger Tool" >>$HOME/.profile
    echo 'alias sxtevtmergerjl "python '$HOME/auxpyscrpt/$scrptname' "' >>$HOME/.profile
    echo " The alias command \'sxtevtmergerjl\' is added to file : $HOME/.profile "

else 

    echo "#SXT PyJulia Events Merger Tool" >>$HOME/.profile
    echo 'alias sxtevtmergerjl "python '$HOME/auxpyscrpt/$scrptname' "' > $HOME/.profile
    echo " The alias command \'sxtevtmergerjl\' is added to file : $HOME/.profile "

endif
       

