#!/bin/bash

#Decision about your working terminal...

unameOut="$(uname -s)"
case "${unameOut}" in
    Linux*)     machine=Linux;;
    Darwin*)    machine=Mac;;
    CYGWIN*)    machine=Cygwin;;
    MINGW*)     machine=MinGw;;
    *)          machine="UNKNOWN:${unameOut}"
esac
echo ${machine}


#Write and decide the default python version in your computer
verdist="v01"
scrptname=`ls sxt_gti*merger*.py` 
juliadirname="./sxtjuliamodule"


mkdir -p $HOME/auxpyscrpt/

cp -R ./sxtjuliamodule $HOME/auxpyscrpt/SXTMERGER_JULIA

readmefilestem="readme"
outreadmestem="pyjulia_sxtevtmerger_help_${verdist}"

docdir=$HOME/auxpyscrpt/docs

mkdir -p ${docdir}

for filtyp in pdf html
do 
    #Adding pdf/html versions of readme to docs
    if [ -f "${readmefilestem}.${filtyp}" ]; 
    then
        echo ${readmefilestem}.${filtyp}
        cp ${readmefilestem}.${filtyp} ${docdir}/${outreadmestem}.${filtyp};
        echo "The help file ${outreadmestem}.${filtyp} is added to the directory ${docdir}... \n Please read it carefully before using this tool";

    fi
done

#adding/aliasing shortcut to paths....
 
cp ./$scrptname $HOME/auxpyscrpt/

    
if [ -f $HOME/.bashrc ]; then 

    sed -i '/PyJulia/d' $HOME/.bashrc
    sed -i '/sxtevtmergerjl/d' $HOME/.bashrc
    echo "#SXT PyJulia Events Merger Tool" >>$HOME/.bashrc
    echo 'alias sxtevtmergerjl="python '$HOME/auxpyscrpt/$scrptname' "' >>$HOME/.bashrc
    echo " The alias command is added to file : $HOME/.bashrc "

elif [ -f $HOME/.profile ]; then

    sed -i '/PyJulia/d' $HOME/.profile
    sed -i '/sxtevtmergerjl/d' $HOME/.profile
    echo "#SXT PyJulia Events Merger Tool" >>$HOME/.profile
    echo 'alias sxtARFModule="python '$HOME/auxpyscrpt/$scrptname3' "' >>$HOME/.profile
    echo " The alias command is added to file : $HOME/.profile "

else

    echo "#SXT PyJulia Events Merger Tool" >$HOME/.profile
    echo 'alias sxtARFModule="python '$HOME/auxpyscrpt/$scrptname3' "' > $HOME/.profile
    echo " The alias command is added to file : $HOME/.profile "

fi

 



