#!/usr/bin/env python

#------------------Readme/help content of the script...
'''
user@p31125417:~/Desktop/SXTPYJULIAMERGER_v02> sxtevtmergerjl --help         
=========================================================================
                 Running " SXT Events Merger Script" 
                 Source Module: /home/user/auxpyscrpt/sxt_gti_corr_evt_merger_Julia_v01.py 
                 Version: v01, Release Date: 2019-06-20 

                 Uses "The Julia based SXT merger Tool", Developed By : 
                 Prof. Gulab C. Dewangan, IUCAA, Pune on  29 October 2018 
 
                 Recently added with a python wrapper module on 2019-06-19 by    : 
                 Sunil Chandra (CSR-NWU Potchefstroom / TIFR-Mumbai)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Description: This tool merges the events files using the Julia based module which considers individual SXT frames and removes overlapping and cprrupt ones.
Please go through the 'readme' file distributed with the 'archived distribution' for a clearer understanding of the Tools.
Contacts : 
 Sunil Chandra (for python/julia related general issues; sunil.chandra355@gmail.com)
 Prof. G. C. Dewangan (for general julia related and SXT merger related issues; gulabd@iucaa.in) 
 Ms. Nilima Kamble (For any related issues; nilima@tifr.res.in)
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=========================================================================

Usage: sxt_gti_corr_evt_merger_Julia_v01.py [options] 

Options:
  -h, --help            show this help message and exit
  -l LISTFILE, --listfile=LISTFILE
                        Input File List with full path of level2 cleaned
                        events files
  -o OUTEVTF, --outevtf=OUTEVTF
                        The Name of output events file   Default =
                        OutPut_Evts.fits
  --sxtjuliadir=SXTJULIADIR
                        The directory where you have kept all SXT related
                        julia code...Default is 'None' which is equivalent to
                        '$HOME/auxpyscrpt/SXTMERGER_JULIA/sxt'   You may use
                        any of [None, 'default', 'Default', 'DEFAULT', 0] for
                        default option
user@p31125417:~/Desktop/SXTPYJULIAMERGER_v02> ./install_sxtpyjuliamerger.sh 
Linux
readme.pdf
The help file pyjulia_sxtevtmerger_help_v01.pdf is added to the directory /home/user/auxpyscrpt/docs... \n Please read it carefully before using this tool
readme.html
The help file pyjulia_sxtevtmerger_help_v01.html is added to the directory /home/user/auxpyscrpt/docs... \n Please read it carefully before using this tool
 The alias command is added to file : /home/user/.bashrc 
user@p31125417:~/Desktop/SXTPYJULIAMERGER_v02> sxtevtmergerjl --help         
=========================================================================
                 Running " SXT Events Merger Script" 
                 Source Module: /home/user/auxpyscrpt/sxt_gti_corr_evt_merger_Julia_v01.py 
                 Version: v01, Release Date: 2019-06-20 

                 Uses "The Julia based SXT merger Tool", Developed By : 
                 Prof. Gulab C. Dewangan, IUCAA, Pune on  29 October 2018 
 
                 Recently added with a python wrapper module on 2019-06-19 by    : 
                 Sunil Chandra (CSR-NWU Potchefstroom / TIFR-Mumbai)
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Description: This tool merges the events files using the Julia based module which considers individual SXT frames and removes overlapping and cprrupt ones.Please go through the 'readme' file distributed with the 'archived distribution' for a clearer understanding of the Tools.
Contacts : 
 Sunil Chandra (for python/julia related general issues; sunil.chandra355@gmail.com)
 Prof. G. C. Dewangan (for general julia related and SXT merger related issues; gulabd@iucaa.in) 
 Ms. Nilima Kamble (For any related issues; nilima@tifr.res.in)
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
=========================================================================

Usage: sxt_gti_corr_evt_merger_Julia_v01.py [options] 

Options:
  -h, --help            show this help message and exit
  -l LISTFILE, --listfile=LISTFILE
                        Input File List with full path of level2 cleaned
                        events files
  -o OUTEVTF, --outevtf=OUTEVTF
                        The Name of output events file   Default =
                        OutPut_Evts.fits
  --sxtjuliadir=SXTJULIADIR
                        The directory where you have kept all SXT related
                        julia code...Default is 'None' which is equivalent to
                        '$HOME/auxpyscrpt/SXTMERGER_JULIA/sxt'   You may use
                        any of [None, 'default', 'Default', 'DEFAULT', 0] for
                        default option
'''
#---------------------------------------------------------------------------------------


def print_preamble(prog, version):
    str2prnt = "=========================================================================\n"

    str2prnt += "\t \t Running \" SXT Events Merger Script\" \n \t \t Source Module: {} \n \t \t Version: {}, Release Date: 2019-06-20 \n".format(prog, version)
    str2prnt += "\n \t \t Uses \"The Julia based SXT merger Tool\", Developed By : \n \t\t Prof. Gulab C. Dewangan, IUCAA, Pune on  29 October 2018 \n \n \t \t Recently added with a python wrapper module on 2019-06-19 by \t : \n \t \t Sunil Chandra (CSR-NWU Potchefstroom / TIFR-Mumbai)\n"
    str2prnt += "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n"
    str2prnt += "Description: This tool merges the events files using the Julia based module which considers individual SXT frames and removes overlapping and cprrupt ones."
    str2prnt += "Please go through the 'readme' file distributed with the 'archived distribution' for a clearer understanding of the Tools.\n"
    str2prnt += "Contacts : \n Sunil Chandra (for python/julia related general issues; sunil.chandra355@gmail.com)\n Prof. G. C. Dewangan (for general julia related and SXT merger related issues; gulabd@iucaa.in) \n Ms. Nilima Kamble (For any related issues; nilima@tifr.res.in)\n "
    str2prnt += "++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n"
    str2prnt += "=========================================================================\n"
    print (str2prnt)

#----------- Main Program Starts from here....

def make_juliacode( outcode = "sxt_run_code.jl", sxtjuliadir="/soft/julia_load/sxt/", evtfilelist = None, outevetsfilename = None) :

    import os

    fl = open(outcode, 'w')
   
    fl.write("push!(LOAD_PATH, \"{}\")\n".format(sxtjuliadir) )
    fl.write("using SXTTools\n")
    fl.write("sxt_l2evtlist_merge(\"{}\",\"{}\")\n".format(evtfilelist, outevetsfilename))

    fl.close()

    if os.path.exists(outcode) :

        fl2ret = outcode
    else :
        fl2ret = None

    return fl2ret


def run_julia(outcode = "sxt_run_code.jl", sxtjuliadir="/soft/julia_load/sxt/", evtfilelist = None, outevetsfilename = None ) :

    import os
    #import Pkg

    try :
        import julia
    except :
        print ("Either 'pyjulia' and/or 'julia' is not installed or not in default $PATH \n Install julia version 1.0.3 or later and 'python -m pip install --user julia' or 'python3 -m pip install --user julia' in your terminal \n Then re-run this tool again...")
        os._exit(0)

    julia.install()

    j = julia.Julia(compiled_modules=False)

    codefile = make_juliacode(outcode = outcode, sxtjuliadir=sxtjuliadir, evtfilelist = evtfilelist, outevetsfilename = outevetsfilename)

    j.include(codefile)

    #j.eval("importall julia_util")

    if os.path.exists(outevetsfilename) :

        return outevetsfilename

    else :

        return None



def main():

    import os, sys
    import optparse
    
    #version = "0.7-py3"

    usage = "usage: %prog [options] "
    version = sys.argv[0]
    prog = version

    version = os.path.splitext(os.path.basename(version))[0]
    ver4getjulver = version
    version = version.split("_")[-1]

    print_preamble(prog, version)

    usage = "usage: %prog [options] "

    parser = optparse.OptionParser(usage)
                         
    parser.add_option("-l","--listfile",dest="listfile",
                      help="Input File List with full path of level2 cleaned events files",
                      default = None)
                      

    parser.add_option("-o","--outevtf",dest="outevtf",
                      help="The Name of output events file \n Default = OutPut_Evts.fits",
                      default="OutPut_Evts.fits")

    #parser.add_option("-n", "--runNum", dest="runNum", help="Type 0 or negative integer if you are running julia on your computer for the first time... otherwise any other positive number..Default = 1 ", default = 1)

    parser.add_option("", "--sxtjuliadir", dest="sxtjuliadir", help="The directory where you have kept all SXT related julia code...Default is 'None' which is equivalent to '$HOME/auxpyscrpt/SXTMERGER_JULIA/sxt' \n You may use any of [None, 'default', 'Default', 'DEFAULT', 0] for default option ", default = None)
                  
    (options, args) = parser.parse_args()

    if len(sys.argv[1:]) == 0 :
        parser.print_help()
        parser.exit()
    

    listfname, outevtfl = options.listfile, options.outevtf
    sxtjuliadir = options.sxtjuliadir

    if sxtjuliadir in [None, 'default', 'Default', 'DEFAULT', 0] :

        home = os.environ['HOME']
        sxtjuliadir = "{}/auxpyscrpt/SXTMERGER_JULIA/sxt".format(home)


    defjulcodename = "sxt_run_code.jl"
    #Running julia merger tool...
    stts = run_julia(outcode = defjulcodename, sxtjuliadir=sxtjuliadir, evtfilelist = listfname, outevetsfilename = outevtfl )

    os.remove(defjulcodename)

    if stts != None :

        print ("Congratulations!!! ... Please use events file {} in current dir for your work...".format(stts))


if __name__ == "__main__":
    main()


